## libserial 0.6.0~rc2+svn122

=== doc/user_manual/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/LibSerial.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/LibSerial.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/LibSerial"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/LibSerial"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

## libserial 0.6.0~rc1

=== debian/changelog ===
libserial (0.6.0~rc1-0ubuntu4) trusty; urgency=medium

  * Use dh-autoreconf instead of autotools-dev to also fix FTBFS on ppc64el by
    getting new libtool macros (still updates config.{sub,guess}).

 -- Logan Rosen <logan@ubuntu.com>  Wed, 05 Mar 2014 19:51:44 -0500

libserial (0.6.0~rc1-0ubuntu3) quantal; urgency=low

  * Fix FTBFS with gcc-4.7.
  * Using source format 3.0 (quilt).
  * Bumped Standards-Version to 3.9.3.
  * Small cleanup: unnecessary inclusion in debian/rules, package short 
    descriptions, copyright file references, watch file.

 -- Ilya Barygin <randomaction@ubuntu.com>  Sat, 29 Sep 2012 22:34:50 +0400

libserial (0.6.0~rc1-0ubuntu2) natty; urgency=low

  * Replace obsolete sip build-depends with build-dep on python-sip-dev

 -- Scott Kitterman <scott@kitterman.com>  Fri, 28 Jan 2011 11:04:51 -0500

libserial (0.6.0~rc1-0ubuntu1) lucid; urgency=low

  * New upstream release.
  * debian/control:
    - Bump Standards.
    - Build-depends on python-sip4-dev,python-sip4,sip4.
  * Drop 01-add-pkconfig-file.patch, libserial.pc is now provided by upstream.
  * Drop 02-add-missing-includes.patch, applied by upstream and no longer
    needed.
  * Don't install todo.3.gz file as manpage (LP: #485603).

 -- Alessio Treglia <quadrispro@ubuntu.com>  Tue, 02 Feb 2010 19:42:15 +0100

libserial (0.5.2-0ubuntu2) karmic; urgency=low

  * Add missinc include to fix FTBFS with g++ 4.4.

 -- Michael Bienia <geser@ubuntu.com>  Mon, 05 Oct 2009 22:40:17 +0200

libserial (0.5.2-0ubuntu1) hardy; urgency=low

  * Initial packaging (LP: #162966)

 -- David Morris <david.morris@greenacre.no-ip.com>  Thu, 15 Nov 2007 11:31:25 +0000

=== debian/control ===
Source: libserial
Section: devel
Priority: optional
Homepage: http://libserial.sourceforge.net
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: David Morris <david.morris@greenacre.no-ip.com>
Build-Depends: debhelper (>= 5),
 dh-autoreconf,
 cdbs,
 intltool,
 doxygen,
 python-sip-dev
Standards-Version: 3.9.3

Package: libserial0
Section: libs
Suggests: libserial-doc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Serial port programming in C++ under POSIX operating system
 A collection of C++ classes which allow the serial port on POSIX systems to be
 accessed like an iostream object. Special functions are provided for setting
 various parameters of the serial port such as the baud rate, character size,
 flow control and other.
 .
 Provides the libserial library

Package: libserial-dev
Section: libdevel
Suggests: libserial-doc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libserial0 (=${binary:Version})
Description: Serial port programming in C++ -- development files
 A collection of C++ classes which allow the serial port on POSIX systems to be
 accessed like an iostream object. Special functions are provided for setting
 various parameters of the serial port such as the baud rate, character size,
 flow control and other.
 .
 This package contains the development libraries and headers

Package: libserial-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Serial port programming in C++ -- documentation
 A collection of C++ classes which allow the serial port on POSIX systems to be
 accessed like an iostream object. Special functions are provided for setting
 various parameters of the serial port such as the baud rate, character size,
 flow control and other.
 .
 Provides the documention for the library and development packages

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/autoreconf.mk

DEB_INSTALL_CHANGELOGS_ALL := ChangeLog
DEB_INSTALL_DOCS_ALL := -XREADME

build/libserial-doc::
	$(MAKE) -C examples clean
	$(MAKE) docs

binary-install/libserial-dev::
	rm -rf debian/libserial-dev/usr/share/doc/libserial-dev
	ln -s libserial0 debian/libserial-dev/usr/share/doc/libserial-dev
	
clean::
	if [ -e examples/Makefile ] ; then $(MAKE) -C examples clean ; fi ;
	if [ -e doc/Makefile ] ; then $(MAKE) -C doc clean ; fi ;
	if [ -e doc/man ] ; then rm -rf doc/man ; fi ;
	if [ -e doc/html ] ; then rm -rf doc/html ; fi ;

## libserial 0.6.0~rc2%2Bsvn122

=== debian/control ===
Source: libserial
Section: devel
Priority: optional
Homepage: http://libserial.sourceforge.net
Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
Uploaders: David Morris <dave@code-fish.co.uk>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               docbook,
               graphviz,
               intltool,
               libboost-dev,
               libboost-test-dev,
               python-sip-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/collab-maint/libserial.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/libserial.git

Package: libserial0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Serial port programming in C++ under POSIX operating system
 A collection of C++ classes which allow the serial port on POSIX systems to be
 accessed like an iostream object. Special functions are provided for setting
 various parameters of the serial port such as the baud rate, character size,
 flow control and other.
 .
 Provides the libserial library

Package: libserial-dev
Section: libdevel
Suggests: libserial-doc
Architecture: any
Depends: libserial0 (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Serial port programming in C++ -- development files
 A collection of C++ classes which allow the serial port on POSIX systems to be
 accessed like an iostream object. Special functions are provided for setting
 various parameters of the serial port such as the baud rate, character size,
 flow control and other.
 .
 This package contains the development libraries and headers

Package: libserial-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Serial port programming in C++ -- documentation
 A collection of C++ classes which allow the serial port on POSIX systems to be
 accessed like an iostream object. Special functions are provided for setting
 various parameters of the serial port such as the baud rate, character size,
 flow control and other.
 .
 Provides the documentation for the library and development packages

## libserial 0.6.0~rc2+svn122

=== debian/changelog ===
libserial (0.6.0~rc2+svn122-4) unstable; urgency=medium

  * Make it build with -A and -B to help Debian buildds.
    - run tests only in -B mode.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 14 Sep 2015 08:34:07 +0200

libserial (0.6.0~rc2+svn122-3) unstable; urgency=medium

  * Upload with the all package, it fails to build in source-only mode.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 11 Sep 2015 19:05:48 +0200

libserial (0.6.0~rc2+svn122-2) unstable; urgency=medium

  * Update my uid.
  * Fix typo in package description.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 11 Sep 2015 18:13:25 +0200

libserial (0.6.0~rc2+svn122-1) unstable; urgency=medium

  * New upstream snapshot.
    - drop all patches, accepted upstream.
  * Add graphviz as b-d, helping with doc generation.
    - remove .md5 and .map files.
  * Fix copyright file, the correct license is GPL-2+,
    a *great* thanks goes to Thorsten Alteholz, for the
    help!

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Mon, 20 Apr 2015 18:49:54 +0200

libserial (0.6.0~rc1+svn114-1) unstable; urgency=medium

  * Initial release (Closes: #780269).

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 11 Mar 2015 10:21:59 +0100

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel --with autoreconf

#override_dh_autoreconf:
#	ln -s /usr/share/libtool/config/ltmain.sh .
#	dh_autoreconf

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/html
	rm -rf doc/man

override_dh_auto_build-indep:
	$(MAKE) docs
	find doc/ -name "*.md5" -delete
	find doc/ -name "*.map" -delete

override_dh_auto_test:
	if [ -f src/unit_tests ]; then ./src/unit_tests; fi

=== debian/watch ===
version=3
opts="uversionmangle=s/rc/~rc/" \
http://sf.net/libserial/libserial-(.+)\.tar\.gz debian uupdate

## libserial 1.0.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.8)

#
# Project version numbering using semantic versioning. See:
# https://semver.org/
#
# These are used to set VERSION and SOVERSION properties of the LibSerial
# libarary. See:
# - https://cmake.org/cmake/help/latest/prop_tgt/SOVERSION.html
# - https://cmake.org/cmake/help/latest/prop_tgt/VERSION.html
#
PROJECT(LibSerial LANGUAGES C CXX VERSION 1.0.0)

#
# Project specific options and variables
#
OPTION(INSTALL_STATIC "Install static library." ON)
OPTION(INSTALL_SHARED "Install shared object library." ON)

INCLUDE(ExternalProject)

ENABLE_TESTING()
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

#
# Create compile_commands.json file so that it may be used by various
# editors/plugins/IDEs that support it.
#
SET(CMAKE_EXPORT_COMPILE_COMMANDS 1)

#
# Use GNU standard installation directories. CMake will use /usr/local
# as the default install directory. Users may override this by setting
# CMAKE_INSTALL_PREFIX. For example:
#
# cd build && cmake -DCMAKE_INSTALL_PREFIX=/usr ..
#
INCLUDE(GNUInstallDirs)

#
# Prefer -pthread compiler and linker flag when using libpthread. This must
# be set before call to FIND_PACKAGE(Threads).
#
SET(THREADS_HAVE_PTHREAD_ARG 1)
FIND_PACKAGE(Doxygen REQUIRED)
FIND_PACKAGE(Boost COMPONENTS unit_test_framework REQUIRED)
FIND_PACKAGE(PythonLibs REQUIRED)
#FIND_PACKAGE(SIP REQUIRED)
FIND_PACKAGE(Threads REQUIRED)

#
# Use -DCMAKE_BUILD_TYPE=Release or -DCMAKE_BUILD_TYPE=Debug to let CMake
# decide whether to use debug or optimization flags. We should not hard-code
# them here. Similarly, let CMake handle flags needed for shared object files
# (such as -fPIC). Additionally, "-pthread" flag will also be handled by CMake
# via the use of CMAKE_THREAD_LIBS_INIT (cmake < 3.1) or Threads::Threads.
#
ADD_DEFINITIONS(
  -Wall
  -Wcast-align
  -Wchar-subscripts
  -Wchkp
  -Wdouble-promotion
  -Wextra
  -Wfatal-errors
  -Wformat
  -Wformat-security
  -Wlogical-op
  -Wno-format-extra-args
  -Wno-long-long
  -Wno-parentheses
  -Wno-psabi
  -Wno-variadic-macros
  -Woverlength-strings
  -Wpacked
  -Wpointer-arith
  -Wunused-local-typedefs
  -Wwrite-strings

  -fstrict-aliasing
  -fno-check-new
  -fno-common
  -fvisibility=default
  -pedantic
  )

#
# We require support for C++14 features in the compiler. This can be
# achieved using CMAKE_CXX_STANDARD in CMake version 3.1 or later. For
# older versions we have to add the compiler flags manually.
#
macro(USE_CXX14)
    IF (CMAKE_VERSION VERSION_LESS "3.1")
        IF (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
            SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11 -fms-extensions")
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++14")
        ENDIF ()
    ELSE ()
        SET(CMAKE_CXX_STANDARD 14)
        SET(CMAKE_STANDARD_REQUIRES ON)
    ENDIF ()
endmacro(USE_CXX14)
USE_CXX14()

SET(GTEST_PREFIX "${CMAKE_CURRENT_BINARY_DIR}/gtest")

EXTERNALPROJECT_ADD(GTestExternal
  PREFIX             "${GTEST_PREFIX}"
  URL https://github.com/google/googletest/archive/release-1.8.1.tar.gz
  URL_HASH SHA1=152b849610d91a9dfa1401293f43230c2e0c33f8
  INSTALL_COMMAND ""
  )

SET(LIBPREFIX "${CMAKE_STATIC_LIBRARY_PREFIX}")
SET(LIBSUFFIX "${CMAKE_STATIC_LIBRARY_SUFFIX}")

SET(GTEST_LOCATION "${GTEST_PREFIX}/src/GTestExternal-build/googlemock/gtest/")
SET(GTEST_LIBRARY  "${GTEST_LOCATION}/${LIBPREFIX}gtest${LIBSUFFIX}")
SET(GTEST_MAINLIB  "${GTEST_LOCATION}/${LIBPREFIX}gtest_main${LIBSUFFIX}")

ADD_LIBRARY(GTest IMPORTED STATIC GLOBAL)
SET_TARGET_PROPERTIES(GTest
  PROPERTIES
  IMPORTED_LOCATION "${GTEST_LIBRARY}"
  IMPORTED_LINK_INTERFACE_LIBRARIES "${CMAKE_THREAD_LIBS_INIT}"
  )

ADD_LIBRARY(GTestMain IMPORTED STATIC GLOBAL)
SET_TARGET_PROPERTIES(GTestMain
  PROPERTIES
  IMPORTED_LOCATION "${GTEST_MAINLIB}"
  IMPORTED_LINK_INTERFACE_LIBRARIES "${GTEST_LIBRARY};${CMAKE_THREAD_LIBS_INIT}"
  )

ADD_DEPENDENCIES(GTest GTestExternal)
ADD_DEPENDENCIES(GTestMain GTestExternal)

EXTERNALPROJECT_GET_PROPERTY(GTestExternal source_dir)

INCLUDE_DIRECTORIES(
  BEFORE ${GTEST_PREFIX}/src/GTestExternal/googletest/include
  ${Boost_INCLUDE_DIRS}
  )

SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
SET(CMAKE_INSTALL_MESSAGE ALWAYS)

ADD_SUBDIRECTORY(examples)
ADD_SUBDIRECTORY(sip)
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(test)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/doxygen.conf.in
  ${CMAKE_CURRENT_BINARY_DIR}/doxygen.conf.in @ONLY
  )

ADD_CUSTOM_TARGET(docs ALL
  ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/doxygen.conf.in
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMENT "Generating API documentation with Doxygen" VERBATIM
)

=== examples/CMakeLists.txt ===
ADD_EXECUTABLE(MainPageExample
  main_page_example.cpp
)

TARGET_LINK_LIBRARIES(MainPageExample
  libserial_static
)

ADD_EXECUTABLE(SerialPortReadExample
  serial_port_read.cpp
)

TARGET_LINK_LIBRARIES(SerialPortReadExample
  libserial_static
)

ADD_EXECUTABLE(SerialPortWriteExample
  serial_port_write.cpp
)

TARGET_LINK_LIBRARIES(SerialPortWriteExample
  libserial_static
)

ADD_EXECUTABLE(SerialPortReadWriteExample
  serial_port_read_write.cpp
)

TARGET_LINK_LIBRARIES(SerialPortReadWriteExample
  libserial_static
)

ADD_EXECUTABLE(SerialStreamReadExample
  serial_stream_read.cpp
)

TARGET_LINK_LIBRARIES(SerialStreamReadExample
  libserial_static
)

ADD_EXECUTABLE(SerialStreamWriteExample
  serial_stream_write.cpp
)

TARGET_LINK_LIBRARIES(SerialStreamWriteExample
  libserial_static
)

ADD_EXECUTABLE(SerialStreamReadWriteExample
  serial_stream_read_write.cpp
)

TARGET_LINK_LIBRARIES(SerialStreamReadWriteExample
  libserial_static
)

=== debian/changelog ===
libserial (1.0.0-9build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:47:17 +0200

libserial (1.0.0-9) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.5.1, no changes needed.

  [ Gianfranco Costamagna ]
  * Update copyright years

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 14 Jul 2023 13:14:24 +0200

libserial (1.0.0-8) unstable; urgency=medium

  * debian/patches/186.patch:
    - upstream proposed patch to fix a build failure with gcc-13
      (Closes: #1037741)
  * Bump std-version to 4.6.2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 14 Jul 2023 10:31:17 +0200

libserial (1.0.0-7) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Team upload

  [ Helmut Grohne ]
  * Non-maintainer upload.
  * Fix duplicate override_dh_auto_configure. (Closes: #985608)

 -- Helmut Grohne <helmut@subdivi.de>  Fri, 19 Mar 2021 18:37:14 +0100

libserial (1.0.0-6) unstable; urgency=medium

  [ Helmut Grohne ]
  * Drop unused python3-sip-dev dependency. (Closes: #984812)
  * Further reduce Build-Depends via <!nocheck> + --disable-tests. (Closes: #984611)

  [ Gianfranco Costamagna ]
  * Bump compat level to 13
  * Add .a and .la file to not-installed

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 18 Mar 2021 14:38:41 +0100

libserial (1.0.0-5) unstable; urgency=medium

  [ Helmut Grohne ]
  * Reduce Build-Depends: (Closes: #982214)
    + Drop unused docbook, doxygen, graphviz, and intltool.
    + Demote sphinx dependencies to B-D-I.

  [ Gianfranco Costamagna ]
  * Upload to sid

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 08 Feb 2021 21:30:32 +0100

libserial (1.0.0-4) unstable; urgency=medium

  * Don't depend on boost anymore
  * Fix doc package

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 11 Mar 2020 09:42:35 +0100

libserial (1.0.0-3) unstable; urgency=medium

  * debian/patches/818005ee7d19b9145bc875cb0ea10422e6e0afaf.patch:
    - upstream patch to fix build on some 32bit systems.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Mar 2020 22:30:02 +0100

libserial (1.0.0-2) unstable; urgency=medium

  * Add patch to fix build on some systems with picky flags

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Feb 2020 15:14:20 +0100

libserial (1.0.0-1) unstable; urgency=medium

  * Update watch file for github move
  * New upstream version 1.0.0
  * update watch file to v4
  * Bump copyright years for Debian packaging
  * Move license to BSD-3-clause, upstream moved it
    and the Debian packaging has been fully done by me
  * Update copyright years
  * Move homepage to github location
  * Bump std-version to 4.5.0
  * Update VCS fields for salsa.d.o move
  * Bump compat level to 12
  * Drop default autoreconf
  * Switch python-sip to python3-sip (Closes: #943101)
    - port to Python3
  * Add libgtest dependency, used for testing
  * Add sphinx and rtd-theme dependencies, used in html generation
  * Switch library SONAME to 1

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Feb 2020 12:34:45 +0100

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,21 @@
 Source: libserial
 Section: devel
 Priority: optional
-Homepage: http://libserial.sourceforge.net
-Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
+Homepage: https://github.com/crayzeewulf/libserial
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
 Uploaders: David Morris <dave@code-fish.co.uk>
-Build-Depends: debhelper (>= 9),
-               dh-autoreconf,
-               docbook,
-               graphviz,
-               intltool,
-               libboost-dev,
-               libboost-test-dev,
-               python-sip-dev
-Build-Depends-Indep: doxygen
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/collab-maint/libserial.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/libserial.git
+Build-Depends: debhelper-compat (= 13),
+               libgtest-dev <!nocheck>,
+               libboost-test-dev <!nocheck>,
+Build-Depends-Indep: python3-sphinx,
+                     python3-sphinx-rtd-theme,
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/libserial
+Vcs-Git: https://salsa.debian.org/debian/libserial.git
 
-Package: libserial0
+Package: libserial1
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -35,7 +33,8 @@
 Section: libdevel
 Suggests: libserial-doc
 Architecture: any
-Depends: libserial0 (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libserial1 (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
 Description: Serial port programming in C++ -- development files
  A collection of C++ classes which allow the serial port on POSIX systems to be
  accessed like an iostream object. Special functions are provided for setting
@@ -48,6 +47,7 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: foreign
 Description: Serial port programming in C++ -- documentation
  A collection of C++ classes which allow the serial port on POSIX systems to be
  accessed like an iostream object. Special functions are provided for setting

=== debian/watch ===
version=4
opts="uversionmangle=s/rc/~rc/" \
https://github.com/crayzeewulf/libserial/tags .*/v?(\d\S+)\.tar\.gz

## libserial 1.0.0+git20250423

=== CMakeLists.txt ===
#
# Minimum version is 3.5 (this supports Ubuntu 16.04 and later, for example)
#
CMAKE_MINIMUM_REQUIRED(VERSION 3.5)

#
# Project version numbering using semantic versioning. See:
# https://semver.org/
#
# These are used to set VERSION and SOVERSION properties of the LibSerial
# libarary. See:
# - https://cmake.org/cmake/help/latest/prop_tgt/SOVERSION.html
# - https://cmake.org/cmake/help/latest/prop_tgt/VERSION.html
#
PROJECT(LibSerial LANGUAGES C CXX VERSION 1.0.0)

option(LIBSERIAL_ENABLE_TESTING "Enables building unit tests" ON)
option(LIBSERIAL_BUILD_EXAMPLES "Enables building example programs" ON)
option(LIBSERIAL_PYTHON_ENABLE "Enables building the library with Python SIP bindings" ON)
option(LIBSERIAL_BUILD_DOCS "Build the Doxygen docs" ON)

#
# Project specific options and variables
#
OPTION(INSTALL_STATIC "Install static library." ON)
OPTION(INSTALL_SHARED "Install shared object library." ON)

#
# LibSerial requies a C++ compiler that supports at least C++14 standard
#
SET(CMAKE_CXX_STANDARD 14)
SET(CMAKE_STANDARD_REQUIRES ON)

INCLUDE(ExternalProject)

if (LIBSERIAL_ENABLE_TESTING)
  ENABLE_TESTING()
endif()
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

#
# Create compile_commands.json file so that it may be used by various
# editors/plugins/IDEs that support it.
#
SET(CMAKE_EXPORT_COMPILE_COMMANDS 1)

#
# Use GNU standard installation directories. CMake will use /usr/local
# as the default install directory. Users may override this by setting
# CMAKE_INSTALL_PREFIX. For example:
#
# cd build && cmake -DCMAKE_INSTALL_PREFIX=/usr ..
#
INCLUDE(GNUInstallDirs)

#
# Prefer -pthread compiler and linker flag when using libpthread. This must
# be set before call to FIND_PACKAGE(Threads).
#
SET(THREADS_HAVE_PTHREAD_ARG 1)
if (LIBSERIAL_BUILD_DOCS)
  FIND_PACKAGE(Doxygen REQUIRED)
endif()
if (LIBSERIAL_ENABLE_TESTING)
  FIND_PACKAGE(Boost COMPONENTS unit_test_framework REQUIRED)
endif()
if (LIBSERIAL_PYTHON_ENABLE)
  FIND_PACKAGE(PythonLibs REQUIRED)
endif()
#FIND_PACKAGE(SIP REQUIRED)
FIND_PACKAGE(Threads REQUIRED)

#
# Use -DCMAKE_BUILD_TYPE=Release or -DCMAKE_BUILD_TYPE=Debug to let CMake
# decide whether to use debug or optimization flags. We should not hard-code
# them here. Similarly, let CMake handle flags needed for shared object files
# (such as -fPIC). Additionally, "-pthread" flag will also be handled by CMake
# via the use of CMAKE_THREAD_LIBS_INIT (cmake < 3.1) or Threads::Threads.
#
ADD_DEFINITIONS(
  -Wall
  -Wcast-align
  -Wchar-subscripts
  -Wdouble-promotion
  -Wextra
  -Wfatal-errors
  -Wformat
  -Wformat-security
  -Wlogical-op
  -Wno-format-extra-args
  -Wno-long-long
  -Wno-parentheses
  -Wno-psabi
  -Wno-variadic-macros
  -Woverlength-strings
  -Wpacked
  -Wpointer-arith
  -Wunused-local-typedefs
  -Wwrite-strings

  -fstrict-aliasing
  -fno-check-new
  -fno-common
  -fvisibility=default
  -pedantic
  )

if (LIBSERIAL_ENABLE_TESTING)
  SET(GTEST_PREFIX "${CMAKE_CURRENT_BINARY_DIR}/gtest")

  EXTERNALPROJECT_ADD(GTestExternal
     PREFIX             "${GTEST_PREFIX}"
     URL https://github.com/google/googletest/archive/refs/tags/v1.13.0.tar.gz
     URL_HASH SHA1=bfa4b5131b6eaac06962c251742c96aab3f7aa78
     INSTALL_COMMAND ""
     )

  SET(LIBPREFIX "${CMAKE_STATIC_LIBRARY_PREFIX}")
  SET(LIBSUFFIX "${CMAKE_STATIC_LIBRARY_SUFFIX}")

  SET(GTEST_LOCATION "${GTEST_PREFIX}/src/GTestExternal-build/lib")
  SET(GTEST_LIBRARY  "${GTEST_LOCATION}/${LIBPREFIX}gtest${LIBSUFFIX}")
  SET(GTEST_MAINLIB  "${GTEST_LOCATION}/${LIBPREFIX}gtest_main${LIBSUFFIX}")

  ADD_LIBRARY(GTest IMPORTED STATIC GLOBAL)
  SET_TARGET_PROPERTIES(GTest
    PROPERTIES
    IMPORTED_LOCATION "${GTEST_LIBRARY}"
    IMPORTED_LINK_INTERFACE_LIBRARIES "${CMAKE_THREAD_LIBS_INIT}"
    )

  ADD_LIBRARY(GTestMain IMPORTED STATIC GLOBAL)
  SET_TARGET_PROPERTIES(GTestMain
    PROPERTIES
    IMPORTED_LOCATION "${GTEST_MAINLIB}"
    IMPORTED_LINK_INTERFACE_LIBRARIES "${GTEST_LIBRARY};${CMAKE_THREAD_LIBS_INIT}"
    )

  ADD_DEPENDENCIES(GTest GTestExternal)
  ADD_DEPENDENCIES(GTestMain GTestExternal)

  EXTERNALPROJECT_GET_PROPERTY(GTestExternal source_dir)

  INCLUDE_DIRECTORIES(
    BEFORE ${GTEST_PREFIX}/src/GTestExternal/googletest/include
    ${Boost_INCLUDE_DIRS}
    )
endif()

SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
SET(CMAKE_INSTALL_MESSAGE ALWAYS)

if (LIBSERIAL_BUILD_EXAMPLES)
  ADD_SUBDIRECTORY(examples)
endif()
if (LIBSERIAL_PYTHON_ENABLE)
  ADD_SUBDIRECTORY(sip)
endif()
ADD_SUBDIRECTORY(src)
if (LIBSERIAL_ENABLE_TESTING)
  ADD_SUBDIRECTORY(test)
endif()

#
# Create pkg-config file for cmake builds as well as autotool builds
#
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(libdir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
set(includedir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR})
set(VERSION ${PROJECT_VERSION})
configure_file(libserial.pc.in libserial.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libserial.pc DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig)

if (LIBSERIAL_BUILD_DOCS)
  CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/doxygen.conf.in
    ${CMAKE_CURRENT_BINARY_DIR}/doxygen.conf.in @ONLY
    )

  ADD_CUSTOM_TARGET(docs ALL
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/doxygen.conf.in
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM
    )
endif()

#
# Packaging support
#
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    add_subdirectory(packaging)
endif()

=== test/CMakeLists.txt ===
ADD_EXECUTABLE(UnitTests
  SerialPortUnitTests.cpp
  SerialStreamUnitTests.cpp
  MultiThreadUnitTests.cpp
  UnitTests.cpp
  )

TARGET_LINK_LIBRARIES(UnitTests
  libserial_static
  GTestMain
)

ADD_EXECUTABLE(unit_tests
  unit_tests.cpp
  )

TARGET_LINK_LIBRARIES(unit_tests
  libserial_static
  ${Boost_LIBRARIES}
)

target_include_directories(UnitTests PRIVATE ${PROJECT_SOURCE_DIR}/src)
target_include_directories(unit_tests PRIVATE ${PROJECT_SOURCE_DIR}/src)


ADD_TEST(NAME UnitTests COMMAND UnitTests)

=== debian/changelog ===
libserial (1.0.0+git20250423-6) unstable; urgency=medium

  * Add some test dependencies to let compiler compile

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Jun 2025 20:52:41 +0200

libserial (1.0.0+git20250423-5) unstable; urgency=medium

  * Fix cmake missing installation in autopkgtests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Jun 2025 13:51:01 +0200

libserial (1.0.0+git20250423-4) unstable; urgency=medium

  * Add simple autopkgtest to test installed package.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Jun 2025 09:31:03 +0200

libserial (1.0.0+git20250423-3) unstable; urgency=medium

  * Unbreak ABI change, by reverting upstream 283a0febd517b78a042a2f44c7b3d5761f82544c
    (Closes: #1107643)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 11 Jun 2025 11:28:47 +0200

libserial (1.0.0+git20250423-2) unstable; urgency=medium

  * Fix builds on arch all and any by fixing dependencies and rules file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 23 Apr 2025 16:30:04 +0200

libserial (1.0.0+git20250423-1) unstable; urgency=medium

  * New upstream version 1.0.0+git20250423 (Closes: #1041898)
  * Switch to cmake and simplify rules file
    (Closes: #1049826, Closes: #1047546).
  * Add new patch proposed upstream to fix pkgconfig
    file installation
  * Add new patch propoosed upstream to fix build with
    system googletest framework
  * Drop patches, all merged upstream

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 23 Apr 2025 09:19:26 +0200

libserial (1.0.0-10) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Bump std-version to 4.7.2

  [ Tobias Graemer ]
  * Fix occasional exception when writing to the serial port (Closes:
    #1103883)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 22 Apr 2025 15:51:44 +0200

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,18 @@
 Section: devel
 Priority: optional
 Homepage: https://github.com/crayzeewulf/libserial
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
+Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
 Uploaders: David Morris <dave@code-fish.co.uk>
 Build-Depends: debhelper-compat (= 13),
+               cmake,
+               doxygen,
+               graphviz,
                libgtest-dev <!nocheck>,
                libboost-test-dev <!nocheck>,
+               python3-dev,
 Build-Depends-Indep: python3-sphinx,
-                     python3-sphinx-rtd-theme,
-Standards-Version: 4.6.2
+                     python3-sphinx-rtd-theme
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/libserial
 Vcs-Git: https://salsa.debian.org/debian/libserial.git

## libserial 1.0.0+git20250424

=== CMakeLists.txt ===
--- 
+++ 
@@ -110,8 +110,8 @@
 
   EXTERNALPROJECT_ADD(GTestExternal
      PREFIX             "${GTEST_PREFIX}"
-     URL https://github.com/google/googletest/archive/refs/tags/v1.13.0.tar.gz
-     URL_HASH SHA1=bfa4b5131b6eaac06962c251742c96aab3f7aa78
+     URL https://github.com/google/googletest/archive/refs/tags/v1.16.0.tar.gz
+     URL_HASH SHA1=517f27ed21b40f9927ab91f2abc147519cedb5a5
      INSTALL_COMMAND ""
      )

=== debian/changelog ===
libserial (1.0.0+git20250424-1) unstable; urgency=medium

  * New upstream snapshot (fixing doxygen warnings)
  * Refresh patches for new release
  * Add patch proposed upstream to fix build failure with new cmake and googletest
    (Closes: #1113198)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 02 Sep 2025 14:10:26 +0200
